<template>
	<header class="m-auto container py-6 px-8">
		<div class="flex container items-center justify-between">
			<div class="logo">
				<router-link to="/" class="w-64 flex items-center">
					<img class="w-1/3 mr-4" src="../../assets/logo.png" alt="Yu-Gi-Oh">Yu-Gi-Shop
				</router-link>
			</div>
			<nav class="flex items-center">
				<router-link v-if="isGuest" to="/login" class="mr-4">
					Login
				</router-link>
				<router-link v-if="isGuest" to="/register">
					Register
				</router-link>
				<router-link v-if="isAdmin" to="/create"
				             class="transition duration-500 ease m-auto block bg-red-600 hover:bg-red-700 text-white py-2 px-4 rounded mr-8 inline-block text-center cursor-pointer">
					Dashboard Admin
				</router-link>
				<button @click="triggerLogout" v-if="isAuth" class="mr-4">
					Logout
				</button>
				<span v-if="isAuth"
				      class="flex uppercase items-center justify-center w-12 h-12 bg-red-600 text-white rounded-full">
          {{userInfos.username.charAt(0)}}
        </span>
			</nav>
		</div>
	</header>
</template>

<script>
	import AuthService from '../../services/AuthService'
	import {mapActions, mapGetters} from 'vuex'
	import constants from '../../../constants'

	export default {
		data () {
			return {
				authService: AuthService,
			}
		},
		methods: {
			...mapActions([
				'logout'
			]),
			triggerLogout () {
				this.logout()
				if (this.$router.history.current.path !== constants.HOME_PATH) {
					this.$router.push(constants.HOME_PATH)
				}
			}
		},
		computed: {
			...mapGetters([
				'isAuth',
				'isAdmin',
				'isGuest',
				'userInfos',
			])
		}
	}
</script>
